OLD98   equ 1
SetPalette      macro   Pal,Blue,Red,Green
                mov     al,Pal
                out     0A8h,al
                mov     al,Green
                out     0AAh,al
                mov     al,Red
                out     0ACh,al
                mov     al,Blue
                out     0AEh,al
ENDM

KEY_UP      equ     3Ah
KEY_DOWN    equ     3Dh
KEY_RETURN  equ     1Ch
KEY_ESC     equ     00h

MAX_LINES       equ     25
GVRAMseg        equ     0A800h

PortPC34_win    equ      00E8h
PortPC34_addr   equ      00E9h
PortPC34_page   equ      00EAh
ListTopPos      equ      2

RAM_segH        equ     byte ptr [bp-3]
RAM_segL        equ     byte ptr [bp-4]
RAM_seg         equ     word ptr [bp-4]         ; Data window segment
PageNum         equ     word ptr [bp-6]
Counter         equ     word ptr [bp-8]
SegTVRAM        equ     word ptr [bp-10]
ProgSeg         equ     word ptr [bp-12]
CurrentNum      equ     word ptr [bp-14]
MaxList         equ     word ptr [bp-16]
SelectedNum     equ     word ptr [bp-18]
ROW             equ     word ptr [bp-20]
COLUMN          equ     word ptr [bp-22]
COLOR_ATTRIB    equ     byte ptr [bp-24]
CheckSumW       equ     word ptr [bp-26]
ColorBits       equ     byte ptr [bp-30]
;AccessMode      equ      byte ptr [bp-32]        ; 1=CGW_acc         0=io_acc
LineCount       equ      byte ptr [bp-34]        ; 
RowG             equ      word ptr [bp-36]        ; sipPʁj
ColumnG          equ      word ptr [bp-38]       ; J
Attrib          equ      byte ptr [bp-40]       ; eLXgAgr[g
ColorBits       equ      byte ptr [bp-42]       ; Frbg}bv
AnkFontPointer  equ      word ptr [bp-44]
GRCGmode        equ      byte ptr [bp-46]

.186
code            segment
                assume cs:code,ds:code,es:code,ss:code
                org    100h
start:          mov     ah,41h
                int     18h
                call    main
                mov     ah,4Ch
                int 21h
;============================================
main            PROC   near
                enter   64,0
                xor     ax,ax
                mov     COLUMN,ax       ; X^bNϐ
                mov     ROW,ax
                mov     GRCGmode,al
                mov     CurrentNum,1

                mov     COLOR_ATTRIB,0E1h
                mov     SegTVRAM,0A000h
                
                call    DisplayTitle
                call    CheckMachine
                jnz     ExitDOS
                call    CheckProgram
                jc      ExitDOS
                mov     ProgSeg,es      ; X^bNϐ
                mov     bx,0040h
                mov     ax,es:[bx]
                add     ax,0100h
                mov     RAM_seg,ax
                call    CheckWindow01
                
                call    HowToUse


EnterSelect:
                call    MakeList
                jc      ExitDOS
                call    SelectList
                jc      ExitDOS
                mov     ax,SelectedNum
                mov     PageNum,ax

                call    PreView
;;                jc      ExitDOS
                jnc     @f
beep3:          call    ShortBeep3
                call    ShortBeep3
        @@:
                call    KeyInput
                cmp     ah,KEY_RETURN
                je      DataSelected
                cmp     ah,KEY_UP
                je      SelPrev
                cmp     ah,KEY_DOWN
                je      SelAdv
                call    ShortBeep
                jmp     EnterSelect
SelPrev:        dec     CurrentNum
                jmp     EnterSelect
SelAdv:         mov     dx,MaxList
                cmp     CurrentNum,dx
                jae     EnterSelect
                inc     CurrentNum
                jmp     EnterSelect

DataSelected:   mov     PageNum,ax
if 0
                ; oEBhEԍ1w肵APJEBhE
                mov     al,01h          ; EBhEԍ 01
                or      al,0C0h         ; peB`FbNȂbit1
                mov     dx,PortPC34_win
                out     dx,al
                out     5Fh,al  ; I/O ̌㎞ԑ҂ق悢炵H

                mov     dx,PortPC34_page
                mov     ax,PageNum      ; EMSy[Wԍ
                out     dx,ax           ; AX=y[Wԍ
                out     05Fh,al         ; 
endif
                call    cls
                call    CopyTG_main

                clc
                leave
                ret
ExitDOS:        
                stc
                leave
                ret
main            ENDP
.186
;------------------------------------------------------------------
;       SelectList
;------------------------------------------------------------------
SelectList      PROC   near
                mov     bx,MaxList
                mov     cx,160
                cmp     CurrentNum,0
                jnz     @f
                mov     CurrentNum,1
                jmp     SelectList_0
        @@:     cmp     CurrentNum,15h
                jb      SelectList_0
                mov     CurrentNum,1
SelectList_0:
                mov     al,0C5h
                call    ChangeAttrib
SelectList_ent: 
                call    KeyInput
                mov     al,0E1h
                call    ChangeAttrib
                cmp     ah,KEY_DOWN
                jne     DOWN_F
                inc     CurrentNum
                mov     bx,MaxList
                cmp     CurrentNum,bx
                jbe     @f
                mov     CurrentNum,1
        @@:     jmp     Reent
     DOWN_F:    cmp     ah,KEY_UP
                jne     UP_F
                mov     bx,MaxList
                cmp     CurrentNum,1
                ja      @f
                mov     CurrentNum,bx
                jmp     Reent
        @@:     dec     CurrentNum
                jmp     Reent
     UP_F:      cmp     ah,KEY_ESC
                je      SelectListCancel
                cmp     ah,KEY_RETURN  
                je      SelectedList
                call    ShortBeep
Reent:          
                mov     al,0C5h
                call    ChangeAttrib
                jmp     SelectList_ent
SelectedList:   mov     al,0E5h
                call    ChangeAttrib
                mov     ax,CurrentNum
                mov     SelectedNum,ax
                clc
                ret
SelectListCancel:
                xor     ax,ax
                mov     SelectedNum,ax
                mov     CurrentNum,ax
                stc
                ret
SelectList      ENDP

ChangeAttrib    PROC   near
                push    ax
                mov     dx,0
                mov     ax,CurrentNum
                add     ax,ListTopPos
                mul     cx
                mov     di,ax
                add     di,122+2  ; 62 clumn
                pop     ax
                push    cx
                mov     cx,17   ; string length=17
     @@:        
                mov     es:[di+2000h],al
                inc     di
                inc     di
               loop     @b
                xor     dx,dx
                mov     dx,0
                pop     cx
                ret
ChangeAttrib    ENDP

.386
CheckNull16     PROC   near
                mov     cx,16
        @@:
                mov     al,fs:[si]
                inc     si
                or      al,al
                jnz     NotNull
               loop     @b
                stc
                ret
NotNull:        clc
                ret
CheckNull16     ENDP

;----------------------------------------------------------------
;       MakeList        BX
;----------------------------------------------------------------
MakeList        PROC   near
                mov     es,SegTVRAM
                mov     fs,ProgSeg
                mov     si,0800h

                mov     di,160*2+122
                mov     dx,offset ListCaptionU
                call    _puts1_di
                
                mov     MaxList,0
                mov     BX,0
                
EnterList:      add     si,16
                inc     BX
                mov     ax,160
                mov     cx,BX
                mul     cx
                add     ax,(ListTopPos*160+122)
                mov     di,ax

                push    si
                call    CheckNull16
                pop     si
                jc      EndList
                inc     MaxList
                cmp     MaxList,15h
                ja      EndList
                
                mov     al,96h
                call    _putYMDms
                
                mov     ax,fs:[si]          ; num
                or      ah,80h
                call    decimalx2
                mov     al,' '
                call    _putYMDms
        
if 0
                mov     al,fs:[si+2]        ; year 20xx
                cmp     al,80h
                mov     al,20h
                jb      @f
                mov     al,19h
        @@:     
                call    decimalx2
                mov     al,fs:[si+2]        ; year 20xx
                call    decimalx2
                mov     al,' ' ;0F2h
                call    _putYMDms
endif
                mov     al,' '
                call    _putYMDms

if 0
                mov     al,fs:[si+3]        ; Month|week
                shr     al,4
                call    decimalx2
                mov     al,'/';0F3h
                call    _putYMDms
endif
                mov     al,fs:[si+4]        ; day
                call    decimalx2
                mov     al,0F4h
                call    _putYMDms

                mov     al,' '
                call    _putYMDms


                mov     al,fs:[si+5]        ; hour
                call    decimalx2
                mov     al,':'
                call    _putYMDms

                mov     al,fs:[si+6]        ; minutes
                call    decimalx2
                mov     al,' '
                call    _putYMDms

                mov     al,fs:[si+7]        ; sec
                call    decimalx2
                mov     al,0F7h
                call    _putYMDms
                mov     al,96h
                call    _putYMDms

                jmp     EnterList
EndList:
                mov     dx,offset ListCaptionL
                call    _puts1_di
        
                mov     ax,MaxList
                or      ax,ax
                jz      MakeListErr
if 0
                cmp     ax,15h
                jbe      @f
                mov     MaxList,15h
        @@:
endif
                clc
                ret
MakeListErr:    mov     dx,offset listerr
                call    _puts
                stc
                ret
listerr DB      061h,"Lv`ς݃XgɃf[^܂.",13,10,0
MakeList        ENDP

if 0
;----------------------------------------------------------------
;       MakeList
;----------------------------------------------------------------
MakeList        PROC   near
                mov     es,SegTVRAM
                mov     fs,ProgSeg
                mov     si,0800h

                mov     di,160*2+122
                mov     dx,offset ListCaptionU
                call    _puts1_di
                
                mov     MaxList,0
                mov     CurrentNum,0
                
EnterList:      add     si,16
                inc     CurrentNum
                mov     ax,160
                mov     cx,CurrentNum
                mul     cx
                add     ax,(ListTopPos*160+122)
                mov     di,ax

                push    si
                call    CheckNull16
                pop     si
                jc      EndList
                inc     MaxList
                cmp     MaxList,15h
                ja      EndList
                
                mov     al,96h          ; Left
                call    _putYMDms

                mov     ax,fs:[si]          ; num
                call    decimali2
                mov     al,' '
                call    _putYMDms
        
if 0
                mov     al,fs:[si+2]        ; year 20xx
                cmp     al,80h
                mov     al,20h
                jb      @f
                mov     al,19h
        @@:     
                call    decimalx2
                mov     al,fs:[si+2]        ; year 20xx
                call    decimalx2
                mov     al,' ' ;0F2h
                call    _putYMDms
endif
                mov     al,' '
                call    _putYMDms

if 0
                mov     al,fs:[si+3]        ; Month|week
                shr     al,4
                call    decimalx2
                mov     al,'/';0F3h
                call    _putYMDms
endif
                mov     al,fs:[si+4]        ; day
                call    decimalx2
                mov     al,0F4h
                call    _putYMDms

                mov     al,' '
                call    _putYMDms


                mov     al,fs:[si+5]        ; hour
                call    decimalx2
                mov     al,':'
                call    _putYMDms

                mov     al,fs:[si+6]        ; minutes
                call    decimalx2
                mov     al,' '
                call    _putYMDms

                mov     al,fs:[si+7]        ; sec
                call    decimalx2
                mov     al,0F7h
                call    _putYMDms
                mov     al,96h
                call    _putYMDms

                jmp     EnterList
EndList:
                mov     dx,offset ListCaptionL
                call    _puts1_di
        
                mov     ax,MaxList
                or      ax,ax
                jz      MakeListErr
if 0
                cmp     ax,15h
                jbe      @f
                mov     MaxList,15h
        @@:
endif
                clc
                ret
MakeListErr:    mov     dx,offset listerr
                call    _puts
                stc
                ret
listerr DB      061h,"Lv`ς݃XgɃf[^܂.",13,10,0
MakeList        ENDP
endif
;------------------------------------------------------------------
;       _puts1_di
;------------------------------------------------------------------
_puts1_di       PROC   near
                push    ax
                push    bx
                push    si
                push    es
                mov     es,SegTVRAM
                mov     bx,dx
                mov     dl,[bx]
                inc     bx
                mov     ah,0
        @@:     mov     al,[bx]
                or      al,al
                jz      _puts1_di_E
                mov     word ptr es:[di],ax
                mov     byte ptr es:[di+2000h],dl
                inc     bx
                inc     di
                inc     di
                jmp     @b
_puts1_di_E:    
                pop     es
                pop     si
                pop     bx
                pop     ax
                ret
_puts1_di       ENDP

;------------------------------------------------------------------
;       _putYMDms       
;------------------------------------------------------------------
_putYMDms       PROC   near
                mov     ah,00h
                mov     word ptr es:[di],ax
                mov     byte ptr es:[di+2000h],0E1h
                inc     di
                inc     di
                ret
_putYMDms       ENDP

KeyInput        PROC   near
                xor     ax,ax
                int     18h
                ret
KeyInput        ENDP


                


;------------------------------------------------------------------
;       CheckWindow01  es=RAM_Seg
;------------------------------------------------------------------
CheckWindow01   PROC   near
                mov     es,RAM_Seg
                mov     di,1000h
                mov     ax,0FFFFh
                mov     cx,1800h
            rep scasb
                or      cx,cx
                jz      CheckWinErr
                mov     di,1000h
                mov     ax,0000h
                mov     cx,1800h
            rep scasb
                or      cx,cx
                jnz     CheckWinErr
                clc
                ret
CheckWinErr:
                stc
                ret
CheckWindow01   ENDP


;------------------------------------------------------------------
;       CheckProgram    return value AX = segment of data window
;------------------------------------------------------------------
CheckProgram    PROC   near
                mov     ax,0D000h
                mov     es,ax
                mov     si,offset Signature
                mov     di,0030h
                mov     cx,12
           rep  cmpsb
                or      cx,cx
                jz      FoundPC34
                mov     ax,0D400h
                mov     es,ax
                mov     si,offset Signature
                mov     di,0030h
                mov     cx,12
           rep  cmpsb
                or      cx,cx
                jz      FoundPC34
                mov     ax,0FFFFh
                mov     dx,offset no_pc34
                call    _puts
                mov     dx,offset retry_loadpc34
                call    _puts
                stc
                ret
FoundPC34:      
                clc
                ret
Signature       DB      0EBh,10h,00h,00h,54h,58h,54h,43h,50h,59h,33h,34h
CheckProgram    ENDP



;---------------------------------
;       ShortBeep
;---------------------------------
ShortWait       PROC   near
                push    cx
                push    ax
                mov     cx,6543
                jmp     ShortWaitEnt
ShortWait       ENDP

ShortBeep       PROC   near
                push    cx
                push    ax
                mov     al,6
                out     37h,al
                mov     cx,1234
ShortWaitEnt:
        @@:     out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     al,7
                out     37h,al
                pop     ax
                pop     cx
                ret
ShortBeep       ENDP

ShortBeep3      PROC   near
                call    ShortWait
                call    ShortWait
                call    ShortBeep
                call    ShortWait
                call    ShortWait
                call    ShortBeep
                call    ShortWait
                call    ShortWait
                call    ShortBeep
                ret
ShortBeep3      ENDP


;--------------------------------------------------------------------------
;       OpenWindow01  ; oEBhEԍ1w肵AEBhE
;--------------------------------------------------------------------------
OpenWindow01    PROC   near
                mov     BX,PageNum
                mov     ax,RAM_Seg
                mov     al,01h          ; EBhEԍ 01
                or      al,0C0h         ; peB`FbNȂbit1
                mov     dx,PortPC34_win
                out     dx,al
                out     5Fh,al  ; I/O ̌㎞ԑ҂ق悢炵H

                mov     dx,PortPC34_page
                mov     ax,BX           ; EMSy[Wԍ
                out     dx,ax           ; AX=y[Wԍ
                out     05Fh,al         ; 

                push    ds
                mov     ds,RAM_Seg
                mov     si,0            ; EMS RAM char code
                mov     cx,1800h/2
                mov     ax,0FFFFh
        rep     scasw
                pop     ds
                or      cx,cx
                jz      OpenWindow_err
                clc
                ret
OpenWindow_err: 
                push    ROW
                mov     ROW,0
                mov     dx,offset wrong_window_data
                call    _puts
                pop     ROW
                call    ShortBeep3
                stc
                ret
OpenWindow01    ENDP

;--------------------------------------------------------------------------
;       CheckWordSum
;--------------------------------------------------------------------------
CheckWordSum    PROC   near
                push    ds
                mov     ds,RAM_Seg      ; =A500h
                mov     si,0000h
                mov     cx,(80*25)
                xor     ax,ax
                mov     dx,ax
CheckLoopEnt:   lodsw
                add     dx,ax
               loop     CheckLoopEnt
                mov     CheckSumW,dx
                mov     ds,ProgSeg
                
                mov     cl,4
                mov     si,0800h
                mov     bx,SelectedNum
                shl     bx,cl
                mov     ax,ds:[si+bx+8]
                pop     ds

                cmp     ax,CheckSumW
                jne     CheckWSumNG
                clc
                ret
CheckWSumNG:    
                stc
                ret
msg_chksumerr   DB      45h,"SUM ERROR",0
CheckWordSum    ENDP
;--------------------------------------------------------------------------
;       PreView
;--------------------------------------------------------------------------
PreView         PROC   near
                call    ShortBeep
                call    OpenWindow01
                push    es
                push    ds
                mov     ds,RAM_Seg
                mov     es,SegTVRAM

                mov     si,0            ; EMS RAM char code
                mov     di,0            ; VRAM code
                mov     cx,1800h/2
        rep     movsw
IF 0
                mov     si,1800h        ; attrib
                mov     di,2000h        ;
                mov     cx,1800h/2
        rep     movsw   ; Agr[gGAɃ[h]ƃ_ȋ@킠
ENDIF
                mov     si,1800h        ; EMS RAM attrib
                mov     di,2000h        ; VRAM  attribute area
                mov     cx,1800h/2
        @@:     ;   PCIoX@ 98OtBNX rW0001ł́A
                lodsw   ; Agr[gGAɃ[hA
                stosb   ; nOAbv̂ł̂悤
                inc     di      ; oCgœ]ȂȂȂ
               loop     @b

                call    CheckWordSum
if 0
                pushf
                push    di
                mov     di,160-10
                mov     dx,offset msg_chksumerr
                call    _puts1_di
                pop     di
                xor     ax,ax
                int 18h
                popf
endif                
                pop     ds
                pop     es
                ret
PreView         ENDP


;--------------------------------------------------------------------------
;   decimal \i^\Zi̐l\iDI̎wVRAMjAX,DI
;--------------------------------------------------------------------------
decimalx2       PROC   near
                push    si
                push    dx
                push    cx
                push    bx
                push    ax
                lea     si,_hextbl
                mov     dx,ax
                and     ax,00F0h        ; Upper digit
                mov     cx,4
                shr     ax,cl
                mov     bx,ax
                mov     al,cs:[bx+si]
                cmp     al,'0'
                jnz     @f
                test    dh,80h
                jnz     @f
                mov     al,' '
        @@:     mov     ah,00h
                mov     es:[di],ax
                mov     byte ptr es:[di+2000h],0E1h
                inc     di      ; 
                inc     di

                mov     ax,dx
                and     ax,000Fh        ; lower digit
                mov     bx,ax
                mov     al,cs:[bx+si]
                mov     ah,00h
                mov     es:[di],ax
                mov     byte ptr es:[di+2000h],0E1h
                inc     di      ; >>
                inc     di

                pop     ax
                pop     bx
                pop     cx
                pop     dx
                pop     si
                ret
;_hextbl DB      "0123456789ABCDEF"      ; e[u
decimalx2       ENDP
;===========================RAM-->GVRAM=================================
;------------------------------------------------------------------
CopyTG_main     PROC   near
                mov     AnkFontPointer,1400h    ; (80*32*2)
                push    es
                call    ginit2  ; OtBbNGRCGgpJn
                push    ds
                call    Text2GVRAM
                pop     ds
                call    gterm   ; OtBbNGRCGgpI
                pop     es
                ret
CopyTG_main     ENDP

;       Version 1.35
;---------------------------------------------------------------
MakeTileReg     PROC   near
                push    ax
                pushf
                cli
                mov     al,000h
                test    ColorBits,1
                jz      @f
                mov     al,0FFh
       @@:      out     7Eh,al
                mov     al,000h
                test    ColorBits,2
                jz      @f
                mov     al,0FFh
       @@:      out     7Eh,al
                mov     al,000h
                test    ColorBits,4
                jz      @f
                mov     al,0FFh
       @@:      out     7Eh,al
                mov     al,000h
                out     7Eh,al
                popf
                pop     ax
                ret
MakeTileReg     ENDP
;------------------------------------------------------
CGW_Zenkaku8    PROC   near     ;    Sp̏
                mov     di,0
                mov     LineCount,0
                xchg    al,ah           ; eLXĝƂ̋t    
                out     0A1h,al         ; Low
                xchg    al,ah
                out     0A3h,al         ; EHigh
charHtop:       mov     al,LineCount
                or      al,20h          ; line #0 left data
                out     0A5h,al
                in      al,0A9h
                mov     DL,al           ; DLɒ~
                mov     al,LineCount
                or      al,00h          ; line #0 right data
                out     0A5h,al
                in      al,0A9h
                mov     DH,al           ; DHɒ~
                test    Attrib,00000100b ; ]rbg
                jz      @f
                not     dx              ; ]
        @@:     

                test    Attrib,00010000b ; deleteCrbg
                jz      @f
                or     dx,0000100000001000b       ; deleteC
        @@:

                test    Attrib,00001000b ; A_[Crbg
                jz      @f
                cmp     LineCount,15
                jne     @f
                mov     DL,55h         ; 0FFh    ; C
        @@:     
                call    MakeTileReg
                mov     es:[bx+di],DL   ; o
                inc     LineCount       
                add     di,640/8        ; PCVRAMoCginC]ύXj
                cmp     LineCount,16    ; cCinC]ύXj
                jb      charHtop
                ret
CGW_Zenkaku8    ENDP
;------------------------------------------------------

CGW_Zenkaku16   PROC   near     ;    Sp̏
                mov     di,0
                mov     LineCount,0
                xchg    al,ah           ; eLXĝƂ̋t    
                out     0A1h,al         ; Low
                xchg    al,ah
                out     0A3h,al         ; EHigh
char2top:       mov     al,LineCount
                or      al,20h          ; line #0 left data
                out     0A5h,al
                in      al,0A9h
                mov     DL,al           ; DLɒ~
                mov     al,LineCount
                or      al,00h          ; line #0 right data
                out     0A5h,al
                in      al,0A9h
                mov     DH,al           ; DHɒ~
                test    Attrib,00000100b ; ]rbg
                jz      @f
                not     dx              ; ]
        @@:     

                test    Attrib,00010000b ; deleteCrbg
                jz      @f
                or     dx,0000100000001000b       ; deleteC
        @@:

                test    Attrib,00001000b ; A_[Crbg
                jz      @f
                cmp     LineCount,15
                jne     @f
                mov     dx,05555h             ; 0FFFFh    ; C
        @@:     
                call    MakeTileReg
                mov     es:[bx+di],dx   ; o
                inc     LineCount       
                add     di,640/8        ; PCVRAMoCginC]ύXj
                cmp     LineCount,16    ; cCinC]ύXj
                jb      char2top
                ret
CGW_Zenkaku16   ENDP
;----------------------------------------------------------------------------
CGW_Hankaku16   PROC   near     ;  p̏i98ˑpQoCg͑ΏۊOj
                mov     di,0
                mov     LineCount,0

IFDEF   OLD98
Char1Top:       
                push    bx
                mov     bl,LineCount
                mov     bh,0
                add     bx,AnkFontPointer
                mov     al,ds:[bx]         ; ALɒ~
                pop     bx
ELSE
                xchg    al,ah
                out     0A1h,al
                xchg    al,ah
                out     0A3h,al
Char1Top:       mov     al,LineCount
                or      al,20h          ; line #0 left data
                out     0A5h,al
                in      al,0A9h         ; ALɒ~
ENDIF
                test    Attrib,00000100b ; ]rbg
                jz      @f
                not     al
        @@:     
                test    Attrib,00010000b ; deleteCrbg
                jz      @f
                or      al,00001000b     ; deleteC
        @@:
                test    Attrib,00001000b ; A_[Crbg
                jz      @f
                cmp     LineCount,15
                jne     @f
                mov     al,055h     ; 0FFh  ;C
        @@:
                call    MakeTileReg
                mov     es:[bx+di],al
                inc     LineCount
                add     di,(640/8)      ; PCVRAMoCginC]ύXj
                cmp     LineCount,16    ; cCinC]ύXj
                jb      Char1Top
                ret
CGW_Hankaku16   ENDP

;-----------------------------------------------------------------------------
Text2GVRAM    PROC   near
IFDEF   OLD98
                SetPalette 0,15,0,0
ENDIF
                mov     ds,RAM_seg     ;A400h     ; DS=eLXgVRAM
                mov     ax,GVRAMseg     ; ES=OtBbNVRAM
                mov     es,ax
                xor     ax,ax
                mov     bx,ax
                mov     di,ax
                mov     si,ax
                mov     bx,ax
                mov     RowG,ax
                  LineEnt:
                  mov   ColumnG,0

IFDEF   OLD98
                mov     al,6
                out     37h,al
                mov     cx,100h
      @@:       out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
              loop @b
                mov     al,7
                out     37h,al
ENDIF
                  mov   ax,640/8*16     ; PCoCginC]ł͕ύXj
                  mul   RowG             ; s{
                  mov   bx,ax           ; BX=eLXgs[GVRAMʒu

                    CharEnt:
                    mov     ax,RowG      ; eLXgsʒu
                    mov     cx,80       ; ̂WO{inC]ł͕ύXj
                    mul     cx          ;
                    add     ax,ColumnG      ; ɃJʒu𑫂
                    shl     ax,1        ; Q{
                    mov     si,ax       ; si̓eLXgVRAM̕ʒu
                    mov     ax,ds:[si+1800h]  ; Agr[gǂ
                    mov     dl,al       ; z
                    and     dl,1Fh      ; F̓Jbg
                    mov     Attrib,dl   ; i]^񔽓]j
                    shr     al,5        
                    mov     ColorBits,al ; F3bito 0..7
                    mov     ax,ds:[si]  ; P[hǂݏo
                    cmp     ah,00h      ; 1stoCg[Ȃ甼p
                    jz      Hankaku
                    cmp     al,0Bh      ; 1stoCg2Bxxh-20xxh=0BxxhȂ甼p2byte
                    je      Hankaku2B
                    cmp     al,0Ah      ; 1stoCg2Axxh-20xxh=0AxxhȂ甼p2byte
                    je      Hankaku2B
                    cmp     al,09h      ; 1stoCg29xxh-20xxh=09xxhȂ甼p2byte
                    je      Hankaku2B
;Zenkaku:            
                    call    CGW_Zenkaku16 ; Sp̏
                    inc     ColumnG         ; SpȂPɐi߂
                    inc     bx          ; GVRAMʒui߂
                    jmp     ZenHan      ; 
Hankaku2B:          call    CGW_Zenkaku8 ; 1/2p̏
                    jmp     ZenHan
Hankaku:            
ifdef   OLD98
                    push        ax
                    push        bx
                    push        cx
                    push        dx
                    mov     dl,al
                    mov     bx,ds
                    mov     cx,AnkFontPointer
                    sub     cx,2
                    mov     DH,80h
                    mov     AH,14h
                    int     18h
                    mov     al,0Bh
                    out     68h,al
                    pop         dx
                    pop         cx
                    pop         bx
                    pop         ax
ENDIF
                    call    CGW_Hankaku16 ; p̏

ZenHan:             inc     ColumnG         ; SppƂPɐi߂
                    inc     bx          ; GVRAMʒu, ʑSp͂Q
                    cmp     ColumnG,80      ; 80JɒB
                    jb      CharEnt     ; BĂȂԂ͉


                  inc   RowG
                  cmp   RowG,MAX_LINES
                  jb    LineEnt
IFDEF   OLD98
                SetPalette 0,0,0,0
ENDIF
                ret
Text2GVRAM      ENDP

;-------------------------------------
ginit2          PROC   near
                mov     ah,40h          ; enable graphic
                int 18h
                mov     ah,42h          ; 400C
                mov     ch,0C0h         ; nC]ł͎gȂ
                int 18h
                
                mov     al,0Bh          ; cg /code
                out     68h,al
                push    ds
                xor     ax,ax
                mov     dx,ax
                mov     al,byte ptr ds:[0495h] ; GRCGgptO
                mov     GRCGmode,al          ; ۑ
                or      byte ptr ds:[0495h],80h ; GRCGgptO𗧂Ă
                pop     ds
;                mov     al,10001000b    ; GRCGL, TDW, 00,4planeL=0
                mov     al,10000000b    ; GRCGL, TDW, 00,4planeL=0
                out     7Ch,al           ; GRCG [hɈڂ
                xor     ax,ax
                mov     di,ax
                mov     al,0h         ; x^
                out     7Eh,al           ; GRCG tile plane#0
                out     5Fh,al
                out     7Eh,al           ; GRCG tile plane#1
                out     5Fh,al
                out     7Eh,al           ; GRCG tile plane#2
                out     5Fh,al
                out     7Eh,al           ; GRCG tile plane#3
                out     5Fh,al
                mov     cx,8000h/2
                mov     ax,0A800h
                mov     es,ax
                mov     ax,0
         rep    stosw
                mov     al,11000000b    ; GRCGL, TDW, 00,4planeL=0
                out     7Ch,al           ; GRCG [hɈڂ
                call    SetPalette8

                ret
ginit2          ENDP
;-------------------------------------
gterm           PROC   near
                mov     al,0Ah
                out     68h,al          ; R[hANZX[h
                mov     al,00000000b    ; GRCG, TDW, 00,4planeL
                out     7Ch,al          ; CPUANZX[hɖ߂
                xor     ax,ax
                push    ds
                mov     ds,ax
                and     byte ptr ds:[0495h],7Fh ; GRCGgptO
                pop     ds
                ret
gterm           ENDP
;--------------------------------------
SetPalette8     PROC   near
                push    ds
                push    ds
                pop     ds
                mov     si,offset patette_table
                mov     cx,16
        @@:     
                lodsb
                out     0A8h,al
                lodsb
                out     0AAh,al
                lodsb
                out     0ACh,al
                lodsb
                out     0AEh,al
               loop     @b
                pop     ds
                ret
SetPalette8     ENDP    
patette_table   label byte ;    G       R       B
                DB      0,      0,      0,      0
                DB      1,      0,      0,     13
                DB      2,      5,     11,      0
                DB      3,      0,     12,      9
                DB      4,     11,      0,      5
                DB      5,     10,      4,     10
                DB      6,      9,      9,      3
                DB      7,      8,      8,      8
                DB      8,      7,      7,      7
                DB      9,      0,      0,     15
                DB     10,      0,     15,      0
                DB     11,      0,     15,     15
                DB     12,     15,      0,      0
                DB     13,     15,      0,     15
                DB     14,     15,     15,      0
                DB     15,     15,     15,     15
                

;======================================================================
include e:\asmlib\putstrcs.inc
include e:\asmlib\digit.inc
;--------------------------------------
;       CheckMachine    
;--------------------------------------
CheckMachine    PROC   near
                xor     ax,ax
                mov     bx,ax
                mov     es,ax
                mov     al,byte ptr es:[0458h]      ; H98 flag = bit7
                mov     ah,byte ptr es:[0501h]      ; hireso flag = bit3
                mov     dx,offset err_h98
                test    al,80h
                jz      @f
                inc     bl
                call    _puts
        @@:     mov     dx,offset err_hireso
                test    ah,8h
                jz      @f
                inc     bl
                call    _puts
        @@:     or      bl,bl
                ret
err_hireso      DB      0E1h,"nC][V[hł͎gpł܂.",13,10,0
err_h98         DB      0E1h,"H98V[Ył͎gpł܂.",13,10,0
CheckMachine    ENDP
;--------------------------------------
;       DisplayTitle
;--------------------------------------
cls             PROC   near
                mov     dx,offset cls_msg
                mov     ah,9
                int 21h
if 0
                mov     ah,16h
                mov     dx,0E120h
                int     18h
endif
                ret
cls_msg         DB      1Bh,"[2J",13,10,13,10,13,10,'$'
cls             ENDP

DisplayTitle    PROC   near
                call    cls
                mov     dx,offset ttl
                call    _puts
                ret
ttl             DB  0E5h," GETTXT34  Version 1.35  Copyright(C) 2023 ܂ ",13,10,0
DisplayTitle    ENDP

PC34detected    DB  0E1h,"PC34ɕۑꂽ÷ĉ摜ꗗ",13,10,0
UpDown          DB  0E1h,"ŉ摜ԍIENTER",0
ListCaptionU     DB  0E1h,98h,"No.",95h,"date",95h,"time",95h,95h,95h,95h,99h,0
ListCaptionL    DB  0E1h,9Ah,95h,95h,1Eh,1Fh,95h,"SELECT",95h,95h,"RET",95h,9Bh,0
PreviewMsg1     DB  21h,"IƃeLXgʂ̃vr[ɕ\܂.",13,10,0
PreviewMsg2     DB  21h,"OtBbNʂɎʂȂENTERL[ĉ.",13,10,0
PreviewMsg3     DB  21h,"̃f[^IȂ[][]L[ĉ.",13,10,0
PreviewMsg4     DB  21h,"vOIȂ, [ESC]L[ĉ.",13,10,0
no_pc34         DB  0E1h,"PC34RAMgROM D0000h邢 D4000hɑ݂Ă܂.",13,10
                DB  "܂ LoadPC34ō쐬ꂽy[Wf[^݂܂.",13,10,0
retry_loadpc34  DB  0E1h,"LoadPC34 ̎s蒼Ă.",13,10,0
wrong_window_data DB 041h,"EBhE01̃y[WɃy[Wf[^oĂ܂. 炩̃n[hEFÄُł.",13,10,0
;               DB 0C1h,"LoadPC34ō쐬ꂽy[Wf[^݂܂.",13,10,0
;               DB 41h,"̃y[W̃`FbNTُł. \ł܂.",13,10,0

HowToUse        PROC   near
                mov     COLUMN,52
                mov     dx,offset PC34detected
                call    _puts

                push    ROW
                mov     ROW,0
                mov     COLUMN,50
                mov     dx,offset UpDown
                call    _puts
                mov     ROW,11
                mov     COLUMN,4
                mov     dx,offset PreviewMsg1
                call    _puts
                mov     ROW,13
                mov     COLUMN,6
                mov     dx,offset PreviewMsg2
                call    _puts
                mov     ROW,15
                mov     COLUMN,6
                mov     dx,offset PreviewMsg3
                call    _puts
                mov     ROW,17
                mov     COLUMN,6
                mov     dx,offset PreviewMsg4
                call    _puts
                pop     ROW
                ret
HowToUse        ENDP

;---------------------------
code    ends
        end     start

