PortPC34_win    equ      00E8h
PortPC34_addr   equ      00E9h
PortPC34_page   equ      00EAh
.8086
code            segment public use16
                assume cs:code,ds:code
                org 100h  ; MS-DOS COM`vO
start:          jmp     main    ; ɃWv
;----------------------------- static data -----------------------------
                DB      "DATA SIZE:"
ROM_DATA_SIZE   DW      1000h   ; 4KB=1000h, 8KB=2000h, 16KB=4000h
MemOfs          DW      0
MemSeg          DW      0D400h   ; $$$
ROM_DATA_ADDR   label   dword
DOS_handle      DW      5
SegPSP          DW      0
SegWindow       DW      0A400h
ProgramTitle1   DB  1Bh,"[47m"," TXTCPY34  u[gqnlC[Wt@CPC34̃4KBRs[. ",1Bh,"[m",13,10,0
ProgramTitle2   DB  " m LoadPC34 n V1.35  Copyright(C) 2023 ܂",13,10,0
msg_exrom1      DB  "gROM̃AhX",0
msg_exrom2      DB  ":0000PC34CODE ",0
msg_setwindow   DB  "EBhEݒ肵܂.",13,10,0
msg_dataseg1    DB  "  AhX",0
msg_dataseg2    DB  ":1000PC34DATA ",0
notavailable    DB  "gROMD0000,D4000ɋ󂫂܂. sł܂.",13,10,0
ClearMsg        DB      "  ΏۃAhXPC34̃NA܂.",0
NotZeroFilled   DB  "PC34{[h̏Ɏs܂. ",7,"炭RAM{[h݂Ă܂.",13,10,0
;----------------------------- data end ---------------------------------
main:           
                mov     bx,offset StackBase+512 ; X^bNTCY512Bɂ  
                mov     sp,bx   ; X^bN؂l߂
                mov     cl,4    ; pOtPʂɕϊ
                shr     bx,cl   ; iPUj
                inc     bx      ; MCB̂ԂPpOt
                mov     ah,4Ah  ; Đ؂l߃t@NV
                int 21h
                mov     SegPSP,cs
                mov     dx,offset ProgramTitle1
                call    puts
                mov     dx,offset ProgramTitle2
                call    puts

                call    machine_check   ; PC-98ǂ̃`FbN
                mov     al,0FFh         ; G[ԒlFF
                jc      ErrExitDOS      ; L[Β~
                call    CheckMachineH
                jnz     ErrExitDOS      ; NZΒ~
                call    CheckPmode
                jc      ErrExitDOS      ; CYΒ~

                call    MemAlloc128K
                jc      ErrExitDOS
                call    CheckPC34       ; L[Β~
                jc      ErrExitDOS
                call    FillCheck       ; L[Β~
                jc      ErrExitDOS
                
                mov     dx,offset msg_exrom1
                call    puts
                mov     ax,cs:MemSeg
                call    digitx
                mov     dx,offset msg_exrom2
                call    puts2
                mov     dx,offset msg_setwindow
                call    puts

;                call    GetFilename
;                jNc     LoadingFile

; clear memory
                mov     dx,offset ClearMsg
                call    puts
                mov     ah,0
                call    LoadToMem
LoadingFile:
                mov     dx,offset InputFileName
                call    Open_File_DX    ; t@C=DXŃI[v
                jc      ErrExitDOS
                call    Load_Data
                jc      ErrExitDOS

;$$$
                call    Check9821_D0_D4_A4
                jc      ErrExitDOS
                and     ax,0FFFEh
                mov     SegWindow,ax

                mov     es,DataBufferSeg
                mov     es:[0040h],ax   ; window seg addr 

                mov     dx,offset msg_dataseg1
                call    puts
                mov     ax,SegWindow 
                call    digitx
                mov     dx,offset msg_dataseg2
                call    puts2
                mov     dx,offset msg_setwindow
                call    puts


                mov     ah,1
                call    LoadToMem
                call    ClrAbove800
                mov     dx,offset jobend
                call    puts

                mov     al,00h
                jmp     ExitDOS
ErrExitDOS:     call    ErrorMessage

                mov     al,0FFh
ExitDOS:        mov     ah,4Ch
                int 21h
                ret

;MsgSaved        DB "  t@C쐬܂. ",13,10,0
;CreatErrMsg     DB "  t@C̍쐬Ŏs܂. ",13,10,0
;WriteErrMsg     DB "  t@C݂Ŏs܂.",13,10,0
;DataErrMsg      DB "  f[^G[ł."
LoadedMsg       DB "  t@CǍ݂܂. ",13,10,0
OpenErrMsg      DB "  t@C̃I[vŎs܂. ",13,10,0
ReadErrMsg      DB "  t@CǍ݂Ŏs܂.",13,10,0
msg_openfile    DB "  t@C̃I[vF",0
msg_CRLF        DB      13,10,0

jobmsg          DB      "  PC34̃ɃAbv[h܂.",13,10,0
jobmsg_f        DB      13,10,"  NA܂.",13,10,0
jobmsg_can      DB      13,10,"~܂.",13,10,0
jobend          DB      "ł.",13,10,0

;-----------------------------------------------------------------
;       Check9821_D0_D4_A4
;-----------------------------------------------------------------
Check9821_D0_D4_A4      PROC   near
                mov     ax,0F8E8h
                mov     es,ax
                mov     ax,es:[0]
                cmp     ax,2198h
                je      UseA400
                cmp     cs:MemSeg,0D000h
                jne     NotD000
                mov     ax,0D401h
                call    CheckFFFF
                jz      Check9821_E
                mov     ax,0D801h
                call    CheckFFFF
                jz      Check9821_E
                mov     ax,0C801h
                call    CheckFFFF
                jz      Check9821_E
                jmp     @f
    NotD000:    mov     ax,0C800h
                cmp     cs:MemSeg,0D400h
                jne     @f
                mov     ax,0D000h
                jmp     Check9821_E
        @@:     stc
                ret
UseA400:        mov     ax,0A400h
Check9821_E:    clc
                ret
Check9821_D0_D4_A4      ENDP
;-----------------------------------------------------------------
;       CleagePagePC34
;-----------------------------------------------------------------
CleagePagePC34  PROC   near
                mov     es,cs:MemSeg
                xor     ax,ax
                mov     di,ax       ;
                mov     cx,4000h/2
        rep     stosw
                ret
CleagePagePC34  ENDP

;-----------------------------------------------------------------
;       AllocPC34W0P3E  PC34 Window[0],Page[3Eh] to MemSeg
;-----------------------------------------------------------------
AllocPC34W0P3E  PROC   near
                mov     ax,cs:MemSeg
                mov     al,00h          ;oEBhEԍO
                or      al,0C0h         ; peB`FbNȂbit1
                mov     dx,PortPC34_win
                out     dx,al
                out     5Fh,al  ; I/O ̌㎞ԑ҂ق悢炵H

                mov     al,ah
                and     al,11111100b    ; lower bit mask Ă悢
                or      al,00000001b    ; D1 or D5
                mov     dx,PortPC34_addr
                out     dx,al          ; byte
                out     5Fh,al

                mov     dx,PortPC34_page
                mov     ax,003Eh        ; AX=EMSy[Wԍ(3E)
                out     dx,ax           ; 
                out     05Fh,al         ; 
                ret
AllocPC34W0P3E  ENDP

;-----------------------------------------------------------------
;       CheckExist
;-----------------------------------------------------------------
CheckExist      PROC   near
                mov     es,ax
                mov     di,0032h        ; refer to gcpy34.s
                mov     si,offset CheckPatten
                mov     cx,14
        rep     cmpsb
                or      cx,cx
                ret
CheckPatten     DB      0,0,"TXTCPY34",0,0,0,0
CheckExist      ENDP

;-----------------------------------------------------------------
;       CheckFFFF       8KB check       bit 0=1 16KB, bit 0=0 8KB
;-----------------------------------------------------------------
CheckFFFF       PROC   near
                push    es
                push    cx
                push    di
                mov     bx,ax
                and     bx,0FFFEh       ; bit 0=0
                mov     cx,2000h/2      ; =8KB
                test    ax,1
                jz      @f
                shl     cx,1    ; 2000h(W) = 16KB
        @@:     
                mov     es,bx
                mov     di,0
                mov     ax,0FFFFh
           rep  scasw
                or      cx,cx
                mov     ax,bx   ; restore AX
                pop     di
                pop     cx
                pop     es
                ret
CheckFFFF       ENDP

;-----------------------------------------------------------------
;-----------------------------------------------------------------
FillCheck       PROC   near
                mov     es,cs:MemSeg
                xor     ax,ax
                mov     di,ax
                mov     cx,4000/2
           rep  stosw

                xor     ax,ax
                mov     di,ax
                mov     cx,4000/2
           rep  scasw
                or      cx,cx
                jz      Fill_OK
                mov     dx,offset NotZeroFilled
                call    puts
                stc
                ret
Fill_OK:        clc
                ret
FillCheck       ENDP
;-----------------------------------------------------------------
;       CheckPC34
;-----------------------------------------------------------------
CheckPC34       PROC   near
                mov     ax,0D400h
                call    CheckExist
                jz      ExistPC34
                mov     ax,0D000h
                call    CheckExist
                jz      ExistPC34

                mov     ax,0D000h
                call    CheckFFFF
                jz      NoRAM

                mov     ax,0D400h
                call    CheckFFFF
                jz      NoRAM
                mov     dx,offset notavailable
                call    puts2
                stc
                ret
ExistPC34:      mov     cs:MemSeg,ax
                call    CleagePagePC34
                clc
                ret
NoRAM:          mov     cs:MemSeg,ax
                call    AllocPC34W0P3E
                call    CleagePagePC34
                clc
                ret
CheckPC34       ENDP

ClrAbove800     PROC   near
                mov     es,cs:MemSeg
                mov     di,0800h
                mov     cx,800h/2
                xor     ax,ax
        rep     stosw
                ret
ClrAbove800     ENDP

;-----------------------------------------------------------------
;       LoadToMem       ah==1  copy , ah==0  zero fill
;-----------------------------------------------------------------
LoadToMem       PROC   near
                push    es
                push    di
                push    ds
                mov     cx,ROM_DATA_SIZE        ; 4KB
                mov     di,MemOfs
                mov     es,cs:MemSeg
                mov     si,DataBufferOfs
                mov     ds,DataBufferSeg
                shr     cx,1    ; by WORD
                test    ah,1
                jz      @f
           rep  movsw   ; by WORD
                jmp     LoadToMemEnd
           @@:  mov     al,0
                mov     di,0
           rep  stosw   ; by WORD
LoadToMemEnd:   
                pop     ds
                pop     di
                pop     es
                test    ah,1
                mov     dx,offset jobmsg_f
                jz      @f
                mov     dx,offset jobmsg
         @@:    call    puts2
                clc
                ret
LoadToMem       ENDP

;-----------------------------------------------------------------
;       Open_File_DX    return=BX ,DOS file handle
;-----------------------------------------------------------------
Open_File_DX    PROC    near
                push    dx

                mov     dx,offset msg_openfile
                call    puts

                pop     dx
                
                push    dx
                call    puts
                mov     dx,offset msg_CRLF
                call    puts
                pop     dx

                mov     ax,3D00h
                xor     bx,bx
                int 21h
                jc      OpenFail1
                mov     DOS_handle,ax
                mov     dx,offset LoadedMsg
                call    puts
                clc
                ret
                
OpenFail1:      mov     dx,offset OpenErrMsg
                call    puts
                stc
                ret
Open_File_DX    ENDP

;-----------------------------------------------------------------
;       Load_Data       DS:DX   = file buffer, cx=size
;-----------------------------------------------------------------
Load_Data       PROC    near
                mov     bx,DOS_handle    ; int21, func 3F
                mov     cx,ROM_DATA_SIZE

                mov     ax,3F00h        ; DOS function call (read)
                mov     dx,DataBufferOfs

                push    ds
                mov     ds,DataBufferSeg
                int 21h
                mov     dx,ds
                pop     ds
                jc      read_err1
                mov     ROM_DATA_SIZE,ax
                or      ax,ax
                jz      read_err1

                mov     bx,DOS_handle           ; close 
                call    Close_File_BX   
                clc
                ret
read_err1:      
                mov     dx,offset ReadErrMsg
                call    puts
                jmp     read_err_e
read_err_e:
                mov     bx,DOS_handle           ; close
                call    Close_File_BX   
                stc
                ret
Load_Data       ENDP


;-----------------------------------------------------------------
;       Close_File_BX
;-----------------------------------------------------------------
;                PUBLIC  Close_File_BX
Close_File_BX   PROC    near
                mov     ah,3Eh
                xor     dx,dx
                int     21h
                ret
Close_File_BX   ENDP


;-----------------------------------------------------------------
;-----------------------------------------------------------------
_digit_div      DW      10
_digit_zsup     DB      ' '
_hextbl         DB      "0123456789ABCDEF"
$KetaBuf17      DB      "                 "
_convert$end    DB      0
                
;----------------------------------------------
;       digitx  
;----------------------------------------------
                PUBLIC  digitx
digitx          PROC    near
                mov     cx,4
                mov     _digit_zsup,'0'
                mov     _digit_div,16
                call    _digit
                call    puts
                ret
digitx          ENDP

                PUBLIC  _digit
_digit          PROC    NEAR
                push    es
                push    si
                push    bx
                push    ds
                pop     es
                push    ax
                cmp     cx,0FFFFh
                je      Noalign
                xor     dx,dx
                mov     ax,128
                div     _digit_div
                cmp     cx,ax
                jbe     cx_ok1
                mov     cx,ax
cx_ok1:         
                cmp     cx,1
                jae     cx_ok2
                mov     cx,ax
cx_ok2:         nop
Noalign:        nop
                std
                 mov     di,offset ds:_convert$end
                 xor     bx,bx
                 mov     bx,ds:_digit_div
                 mov    al,0
                 stosb   
                pop     ax  ;   ax=value
                xor     dx,dx
_digit_ent:     
                div     bx
                mov     si,offset ds:_hextbl
                add     si,dx
                movsb
                dec     cx
                xor     dx,dx
                or      ax,ax
                jnz     _digit_ent
_digit_end:     
                cmp     cx,33   ; 33
                jae     digit_err
                or      cx,cx
                jz      digit_err
                mov     al,_digit_zsup
digit_spc_loop: stosb
               loop     digit_spc_loop
digit_err:      
                cld
                mov     dx,di
                pop     bx
                pop     si
                pop     es
                ret
_digit          ENDP
;-------------------------------------
MemAlloc128K    PROC   near
                mov     bx,4000h  ; paragraph size*16= byte size 256KB
                inc     bx
                mov     ax,4800h
                int     21h
                jc      mem_err
                mov     DataBufferSeg,ax
                push    es
                mov     es,ax
                mov     di,0
                mov     cx,32768/2 ;
                xor     ax,ax
            rep stosw
                pop     es
                mov     dx,offset msg_mAllocFail  
                call    puts
                clc
                ret
mem_err:        mov     dx,offset err_mAllocFail
                call    puts
                stc
                ret
err_mAllocFail  DB "̋󂫂sĂ̂ősł܂.",13,10,0
;msg_mAllocFail  DB "m.",13,10,0
msg_mAllocFail  DB 13,10,0
MemAlloc128K    ENDP
;-----------------------------------------
;--------------------------------------------------------------------------
;       machine_check   
;--------------------------------------------------------------------------
machine_check   PROC   near
                mov     ah,00
                mov     cx,0FFFFh       ; 悭mꂽ98/AT`FbN
                int 1Ah
                cmp     cx,0FFFFh
                jNE     NotPC98  
                mov     cs:FlagPC98,1
                clc
                ret
NotPC98:        
                mov     dx,offset msg_not98
                call    puts  ; int 21ŕ\
                stc
                ret
FlagPC98        DB      0
machine_check   ENDP

ErrorMessage    PROC   near
                mov     al,cs:FlagPC98
                mov     dx,offset errmsg_E
                or      al,al
                jz      @f
                mov     dx,offset errmsg_J
        @@:     call    puts
                ret
msg_not98       DB      "This machine is not PC-9800 series",13,10,0
errmsg_E        DB      "Program abnormally terminated.",13,10,0
errmsg_J        DB      "yG[zvOُ͈I܂.",13,10,0
ErrorMessage    ENDP

if 0
;-----------------------------------------------------------------
;       GetFilename
;-----------------------------------------------------------------
GetFilename     PROC   near
                cld
                mov     es,SegPSP
                mov     di,offset InputFileName
                mov     si,di
                mov     bx,0080h
                mov     cl,es:[bx]
                mov     ch,0
                cmp     cx,0078h
                jae     GetF_err
                cmp     cx,0
                je      GetF_err
        @@:
                inc     bx
                mov     al,es:[bx]
                cmp     al,' '
                jz      @b
GetF_ent:
                mov     al,es:[bx]
                inc     bx
                cmp     al,0Dh          ; Carridge Return Code
                je      @f
                mov     ds:[di],al
                inc     di
               loop     GetF_ent
      @@:       mov     al,0
                cmp     di,si
                je      GetF_err
                mov     ds:[di],al
                clc
                ret
GetF_err:       
                stc
                ret
GetFilename     ENDP
endif
;--------------------------------------
;       CheckMachineH    ? H98, hireso
;--------------------------------------
CheckMachineH    PROC   near
                xor     ax,ax
                mov     bx,ax
                mov     es,ax
                mov     al,byte ptr es:[0458h]      ; H98 flag = bit7
                mov     ah,byte ptr es:[0501h]      ; hireso flag = bit3
                mov     dx,offset err_h98
                test    al,80h
                jz      @f
                inc     bl
                call    puts
        @@:     mov     dx,offset err_hireso
                test    ah,8h
                jz      @f
                inc     bl
                call    puts
        @@:     or      bl,bl
                ret
err_hireso      DB      "nC][V[hł͎gpł܂.",13,10,0
err_h98         DB      "H98V[Ył͎gpł܂.",13,10,0
CheckMachineH    ENDP

;-----------------------------------------------------------------
;       puts in MS-DOS
;-----------------------------------------------------------------
puts           PROC    near
                push    ax
                push    dx
                push    bx
                mov     bx,dx
puts_ent:       cmp     byte ptr [bx],0
                jz      @f
                inc     bx
                jmp     puts_ent
        @@:
                mov     byte ptr [bx],'$'
                mov     ah,9
                int 21h
                mov     byte ptr [bx],0
                pop     bx
                pop     dx
                pop     ax
                ret
puts            ENDP

;-----------------------------------------------------------------
;       puts in MS-DOS
;-----------------------------------------------------------------
puts2           PROC    near
                push    ax
                push    dx
                push    bx
                mov     bx,dx
                mov     ah,2
puts2_ent:      mov     dl,cs:[bx]
                or      dl,dl
                jz      @f
                int     21h
                inc     bx
                mov     al,6
                out     37h,al
                DW      10 dup(05FE6h)     ; out  5F,al ̖߃f[^
                mov     al,7
                out     37h,al
                call    BeepWait
                jmp     puts2_ent
        @@:     
                pop     bx
                pop     dx
                pop     ax
                ret
puts2           ENDP

BeepWait        PROC   near
                mov     cx,500h
        @@:     DW      24 dup(05FE6h)     ; out  5F,al ̖߃f[^
                loop    @b
                ret
BeepWait        ENDP
.286
;-----------------------------------------------------------------
;       CheckPmode
;-----------------------------------------------------------------
CheckPmode      PROC   near
                smsw    ax
                test    ax,1            ; is PROTECT MODE ?
                jnz     ProtectedMode
real_mode:      clc
                ret
ProtectedMode:  mov     dx,offset pmode_mes
                call    puts2
                stc
                ret
pmode_mes       DB      "Virtual 86 [h(EMM386)ł͎gpł܂.",13,10,0
CheckPmode      ENDP
;============================================

align 2
DataBufferOfs   DW      0
DataBufferSeg   DW      8000h
InputFileName   DB "TXTCPY34.BIN",0, 265 dup(?)
;------------------------------------
StackBase       label word

code    ends
        end     start
