USE_STACK       equ     1
PortPC34_win    equ      00E8h
PortPC34_addr   equ      00E9h
PortPC34_page   equ      00EAh
CURRENT_PAGE    equ      05C5h
PAGENUM_POS     equ      0800h
SEG_TVRAM       equ     0A000h
; X^bNϐ(GLOBAL)
RAM_segH        equ     byte ptr [bp-3]         ; A4
RAM_segL        equ     byte ptr [bp-4]         ; 00
RAM_seg         equ     word ptr [bp-4]         ; A400
PageNum         equ     word ptr [bp-6]
CheckSumW       equ     word ptr [bp-8]
ifdef   USE_STACK
C_VRAM          equ     word ptr [bp-16]
A_VRAM          equ     word ptr [bp-24]
endif
;-----------------------------------------------------------------------------
;  COPY from PC34 RAM to Text VRAM      V1.30  (C)2023 (DOSsoft)
;-----------------------------------------------------------------------------
.186            ; 8086@ɂ͑ΉȂ, P6Ή
include CBUSHEAD.INC
ROM_entry0:     jmp     ROM_entry1      ; offset 0030h
                DB      0,0,"TXTCPY34",0,0,0,0
org   40h
EXEC_SEG        DW      0A400h          
org   42h
                
ROM_entry1:     mov     byte ptr ds:[bx],0C9h
                pushf
                cli     ; ֎~AxN^05ύX
                call    SetIntVect05
                popf
                RETF    ; ߂
;=============== ȉ̃R[hCOPYL[ƂɎs ==========
org   50h
INT05_ENTRY:    pushf
                pusha
                push    ds
                push    es
                xor     ax,ax
                mov     es,ax   ; ēh~tOSYSTEMʈ045FhɎĂ
                mov     al,es:[045Fh]
                or      al,al
                jnz     @f      ; [łȂȂs
                not     al      ; [̂Ƃ̓[łȂ
                mov     es:[045Fh],al   ; 
                call    main    ; {
                xor     ax,ax
                mov     es,ax
                mov     es:[045Fh],al   ; tO[ɖ߂
        @@:     
                pop     es
                pop     ds
                popa
                popf
                iret            ; ܂ł͕ύXȂ
                DD      0       
;----------------------------------------------------------
;org 100h        ; {
main            PROC   near
                enter   34,0
                push    cs
                pop     ds
                mov     ax,cs:EXEC_SEG          ;  CS: needed
                mov     RAM_seg, ax
                mov     CheckSumW, ax

                mov     si,PAGENUM_POS
                mov     ax,cs:[si]
                or      ax,ax
                jnz     @f
                mov     ax,1
                mov     cs:[si],ax
        @@:     
                cmp     ax,0015h        ; DIR_MAX
                jb      @f
                mov     ax,1
                mov     cs:[si],ax
        @@:     
                mov     PageNum,ax
                mov     ah,RAM_segH     ; EBhEaddrԍw肵
                mov     al,01h          ; EBhEԍ01ԍw肵
                mov     bx,PageNum
                call    CreateWindowEMS ; EBhE
                call    TransferTVRAM
ifdef   USE_STACK
                call    FlashPageNum
else
                call    Wait1s
endif
                call    CalcWordSum
                call    MemorizePageNum
                leave
                ret
main            ENDP

SetIntVect05    PROC   near
                mov     ds:[05h*4+0],offset INT05_ENTRY
                mov     ds:[05h*4+2],cs
                ret
SetIntVect05    ENDP

;--------------------------------------------------------------------------
;       CreateWindowEMS input al=Window#,  ah=segment(upper), bx=page#
;--------------------------------------------------------------------------
CreateWindowEMS PROC   near
                push    dx
                or      al,0C0h         ; peB`FbNȂbit1
                mov     dx,PortPC34_win
                out     dx,al
                out     5Fh,al  ; I/O ̌㎞ԑ҂ق悢炵H

                mov     al,ah
                and     al,11111100b    ; lower bit mask Ă悢
                or      al,00000001b    ; D1 or D5
                mov     dx,PortPC34_addr
                out     dx,al          ; byte
                out     5Fh,al

                mov     dx,PortPC34_page
                mov     ax,bx           ; AX=EMSy[Wԍ
                out     dx,ax           ; 
;                out     05Fh,al         ; 

                pop     dx
                ret
CreateWindowEMS ENDP

ifdef   USE_STACK
;--------------------------------------------------------------------------
;       FlashPageNum    PageNum̒lʒɕ\Ďԑ҂ij
;--------------------------------------------------------------------------
FlashPageNum    PROC   near
                push    ds
                push    es
                mov     ax,ss           ; X^bNϐɑޔ̂
                mov     es,ax           ; ES=SSɂ
                mov     ax,SEG_TVRAM
                mov     ds,ax
; push
                mov     bx,(13*80+38)*2 ; ʒ̕\ʒũAhX
                mov     si,bx           ; ̐BX͂Ǝgp
                lea     di,C_VRAM       ; ޔꏊ̓X^bNϐ
                mov     cx,8/2          ; WoCgiSjԂ
        rep     movsw           ; Rs[
                mov     si,bx
                add     si,2000h
                lea     di,A_VRAM    ; ޔꏊX^bNϐ̃AhX
                mov     cx,8/2          ; WoCgiSjԂ
        rep     movsw           ; Rs[

                mov     ax,SEG_TVRAM     ; ESVRAMɖ߂
                mov     es,ax
                mov     di,bx           
                mov     ax,PageNum      ; PageNum̐l
               call     decimalx2       ; 𒆉[Q]\

                mov     ax,SEG_TVRAM     ; \ʒũAgr[gA5ɕύX
                mov     es,ax
                mov     di,bx
                add     di,2000h
                mov     ax,00A5h
                mov     cx,8/2
        rep     stosw   ; Agr[gR[h
                
                call    Wait1s          ; Ƒ҂

                mov     ax,ss           ; ޔ\e𕜋A
                mov     ds,ax           ; DS=SSɂ
                mov     ax,SEG_TVRAM     ; ESVRAM
                mov     es,ax

                mov     di,bx           ; eLXg,R[hʂ
                lea     si,C_VRAM    ; X^bNϐ
                mov     cx,8/2          ; WoCgiSjԂ
        rep     movsw           ; Rs[
                mov     di,bx
                add     di,2000h        ; Agr[gʂ
                lea     si,A_VRAM    ; X^bNϐ
                mov     cx,8/2          ; WoCgiSjԂ
        rep     movsw           ; Rs[

                pop     es
                pop     ds
                ret
FlashPageNum    ENDP
;--------------------------------------------------------------------------
;   decimal \i^\Zi̐l\iDI̎wVRAMjAX,DI
;--------------------------------------------------------------------------
decimalx2       PROC   near
                pusha
                lea     si,_hextbl
                mov     dx,ax
                inc     di      ; >>
                inc     di
                and     ax,00F0h        ; Upper digit
                mov     cx,4
                shr     ax,cl
                mov     bx,ax
                mov     al,cs:[bx+si]
                mov     ah,00h
                mov     es:[di],ax
                inc     di      ; 
                inc     di

                mov     ax,dx
                and     ax,000Fh        ; lower digit
                mov     bx,ax
                mov     al,cs:[bx+si]
                mov     ah,00h
                mov     es:[di],ax
                inc     di
                inc     di
                mov     ax,dx
                popa
                ret
_hextbl DB      "0123456789ABCDEF"      ; e[u
decimalx2       ENDP
endif

;--------------------------------------------------------------------------

;--------------------------------------------------------------------------
;       MemorizePageNum         WX^gp@ύXȂ
;--------------------------------------------------------------------------
MemorizePageNum PROC   near
                push    cs
                pop     es      ; ES=CS=RAM
                mov     si,PAGENUM_POS  ; si=0800h
                mov     ax, cs:[si]     ; ax=N
                mov     cl,4            ;
                mov     bx,ax           ;
                shl     bx,cl           ; bx=N*16
                add     bx,si           ; 08N0h
                mov     cs:[bx],ax      ; =#
                inc     bx              ; 
                inc     bx              ; BX=08N2
                mov     ah,00h
                int     1Ch     ; using es:[bx]
                inc     word ptr cs:[si]        ; [0800h]
                ret
MemorizePageNum ENDP

;--------------------------------------------------------------------------
;       CalcWordSum     RAM_seg:1000-<2800
;--------------------------------------------------------------------------
CalcWordSum     PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                push    si

                push    ds
                
                mov     ax,RAM_seg
                mov     ds,ax
                mov     si,1000h
                mov     cx,(80*25)
                xor     ax,ax
                mov     dx,ax
        @@:     lodsw
                add     dx,ax
               loop     @b
                
                pop     ds

                mov     CheckSumW,dx
                mov     bx,PageNum
                mov     cl,4
                shl     bx,cl
                mov     word ptr cs:[bx+PAGENUM_POS+8],dx
                pop     si
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                clc
                ret
CalcWordSum     ENDP

;--------------------------------------------------------------------------
;       text 8KB  +  attribute 8KB (5760 + 5760 bytes)
;--------------------------------------------------------------------------
TransferTVRAM   PROC   near
                push    ds
                push    es

                mov     bh,RAM_segH     ; segment=A400Ȃ
                mov     bl,0
                mov     ax,SEG_TVRAM
                mov     ds,ax
                mov     es,bx
                
                cmp     bx,0A400h
                jz      @f
                mov     di,0000h        ; EMS̃ItZbg0000h(D0000)
                mov     cx,1000h/2      ; 4KB
           rep  stosw   ; FILL
        @@:
                mov     si,0000h        ; VRAM̃ItZbg0
                mov     di,1000h        ; EMS̃ItZbg1000h(D1000)
                mov     cx,1800h/2      ; 80~38sԂ
           rep  movsw
           
                mov     si,2000h
                mov     di,2800h        ; EMS̃ItZbg2800h(D2800)
                mov     cx,1800h/2      ; 80~38sԂ
                mov     ax,0FF00h
  LowerByte:    lodsb
                inc     si
                stosw
               loop     LowerByte

                pop     es
                pop     ds
                ret
TransferTVRAM   ENDP
;--------------------------- RAM map -----------------
;       offset 
;       0000-----0800---1000-----------2800-----------4000-1
;       program  param  chr codes      char attributes
;
;--------------------------------------------------------------------------
;----------------------{̂ŎgpTu[`----------------
Tone98Set_AX    PROC    near
                push    dx
                mov     DX,3FDBh
                out     DX, AL
                xchg    AL, AH
                out     DX, AL
                pop     dx
                ret
Tone98Set_AX    ENDP
;--------------------------------------------------------------------------
Wait1s          PROC   near
                mov     dx,005Fh
                mov     al,6
                out     37h,al
                mov     cx,2023;     1800 ; 1.36kHzx
        @@:     mov     ax,cx
                call    Tone98Set_AX
                DB      14 dup(0EEh)     ; out  dx,al ̖߃f[^
                dec     cx
                cmp     cx,400  ; 6kHzx܂
                ja      @b
NoBeepNoWait:
                mov     al,7
                out     37h,al
                mov     ax,1229 ; (04CDh) W̎g 2kHz 
                call    Tone98Set_AX
if 1
                mov     cx,100h
        @@:     out     5Fh,al
                DB      3 dup(0EEh)     ; out  dx,al ̖߃f[^
               loop     @b
endif
                ret
Wait1s          ENDP

;====================1.30================
.386
include e:\asmlib\instr486.inc
WriteMSR        PROC   near
                pushf   
                cli     
                wbinvd  
                wrmsr   
                popf    
                ret
WriteMSR        ENDP

ROM_entry3:
                push    eax
                push    ecx
                push    edx
                push    es
                xor     ax,ax
                mov     es,ax
                mov     ax,es:[0486h]
                pop     es
                and     ax,0F00h
                cmp     ax,0600h
                jae     P6CPU
                jmp     End_WrMSR
P6CPU:          
                mov     ax,cs
                cmp     ax,0D000h
                je      MSR_D000
                cmp     ax,0D400h
                je      MSR_D400
                cmp     ax,0DC00h
                je      MSR_DC00
                jmp     End_WrMSR

MSR_D000:       mov     ECX,026Ah
                rdmsr
                mov     EAX,04040404h   ; D000-D3FF
                call    WriteMSR
                jmp     End_WrMSR

MSR_D400:       mov     ECX,026Ah
                rdmsr
                mov     EDX,04040404h   ; D400-D7FF
                call    WriteMSR
                jmp     End_WrMSR

MSR_DC00:       mov     ECX,026Bh
                rdmsr
                mov     EDX,04040404h   ; DC00-DFFF
                call    WriteMSR
                jmp     End_WrMSR
End_WrMSR:      
                pop     edx
                pop     ecx
                pop     eax
                RETF
code    ends
        end     start

